"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
Generated by https://github.com/foxglove/schemas"""
import builtins
import collections.abc
from . import ArrowPrimitive_pb2 as foxglove_ArrowPrimitive_pb2
from . import CubePrimitive_pb2 as foxglove_CubePrimitive_pb2
from . import CylinderPrimitive_pb2 as foxglove_CylinderPrimitive_pb2
from . import KeyValuePair_pb2 as foxglove_KeyValuePair_pb2
from . import LinePrimitive_pb2 as foxglove_LinePrimitive_pb2
from . import ModelPrimitive_pb2 as foxglove_ModelPrimitive_pb2
from . import SpherePrimitive_pb2 as foxglove_SpherePrimitive_pb2
from . import TextPrimitive_pb2 as foxglove_TextPrimitive_pb2
from . import TriangleListPrimitive_pb2 as foxglove_TriangleListPrimitive_pb2
import google.protobuf.descriptor
import google.protobuf.duration_pb2
import google.protobuf.internal.containers
import google.protobuf.message
import google.protobuf.timestamp_pb2
import sys

if sys.version_info >= (3, 8):
    import typing as typing_extensions
else:
    import typing_extensions

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

@typing_extensions.final
class SceneEntity(google.protobuf.message.Message):
    """A visual element in a 3D scene. An entity may be composed of multiple primitives which all share the same frame of reference."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    TIMESTAMP_FIELD_NUMBER: builtins.int
    FRAME_ID_FIELD_NUMBER: builtins.int
    ID_FIELD_NUMBER: builtins.int
    LIFETIME_FIELD_NUMBER: builtins.int
    FRAME_LOCKED_FIELD_NUMBER: builtins.int
    METADATA_FIELD_NUMBER: builtins.int
    ARROWS_FIELD_NUMBER: builtins.int
    CUBES_FIELD_NUMBER: builtins.int
    SPHERES_FIELD_NUMBER: builtins.int
    CYLINDERS_FIELD_NUMBER: builtins.int
    LINES_FIELD_NUMBER: builtins.int
    TRIANGLES_FIELD_NUMBER: builtins.int
    TEXTS_FIELD_NUMBER: builtins.int
    MODELS_FIELD_NUMBER: builtins.int
    @property
    def timestamp(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """Timestamp of the entity"""
    frame_id: builtins.str
    """Frame of reference"""
    id: builtins.str
    """Identifier for the entity. A entity will replace any prior entity on the same topic with the same `id`."""
    @property
    def lifetime(self) -> google.protobuf.duration_pb2.Duration:
        """Length of time (relative to `timestamp`) after which the entity should be automatically removed. Zero value indicates the entity should remain visible until it is replaced or deleted."""
    frame_locked: builtins.bool
    """Whether the entity should keep its location in the fixed frame (false) or follow the frame specified in `frame_id` as it moves relative to the fixed frame (true)"""
    @property
    def metadata(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[foxglove_KeyValuePair_pb2.KeyValuePair]:
        """Additional user-provided metadata associated with the entity. Keys must be unique."""
    @property
    def arrows(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[foxglove_ArrowPrimitive_pb2.ArrowPrimitive]:
        """Arrow primitives"""
    @property
    def cubes(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[foxglove_CubePrimitive_pb2.CubePrimitive]:
        """Cube primitives"""
    @property
    def spheres(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[foxglove_SpherePrimitive_pb2.SpherePrimitive]:
        """Sphere primitives"""
    @property
    def cylinders(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[foxglove_CylinderPrimitive_pb2.CylinderPrimitive]:
        """Cylinder primitives"""
    @property
    def lines(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[foxglove_LinePrimitive_pb2.LinePrimitive]:
        """Line primitives"""
    @property
    def triangles(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[foxglove_TriangleListPrimitive_pb2.TriangleListPrimitive]:
        """Triangle list primitives"""
    @property
    def texts(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[foxglove_TextPrimitive_pb2.TextPrimitive]:
        """Text primitives"""
    @property
    def models(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[foxglove_ModelPrimitive_pb2.ModelPrimitive]:
        """Model primitives"""
    def __init__(
        self,
        *,
        timestamp: google.protobuf.timestamp_pb2.Timestamp | None = ...,
        frame_id: builtins.str = ...,
        id: builtins.str = ...,
        lifetime: google.protobuf.duration_pb2.Duration | None = ...,
        frame_locked: builtins.bool = ...,
        metadata: collections.abc.Iterable[foxglove_KeyValuePair_pb2.KeyValuePair] | None = ...,
        arrows: collections.abc.Iterable[foxglove_ArrowPrimitive_pb2.ArrowPrimitive] | None = ...,
        cubes: collections.abc.Iterable[foxglove_CubePrimitive_pb2.CubePrimitive] | None = ...,
        spheres: collections.abc.Iterable[foxglove_SpherePrimitive_pb2.SpherePrimitive] | None = ...,
        cylinders: collections.abc.Iterable[foxglove_CylinderPrimitive_pb2.CylinderPrimitive] | None = ...,
        lines: collections.abc.Iterable[foxglove_LinePrimitive_pb2.LinePrimitive] | None = ...,
        triangles: collections.abc.Iterable[foxglove_TriangleListPrimitive_pb2.TriangleListPrimitive] | None = ...,
        texts: collections.abc.Iterable[foxglove_TextPrimitive_pb2.TextPrimitive] | None = ...,
        models: collections.abc.Iterable[foxglove_ModelPrimitive_pb2.ModelPrimitive] | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["lifetime", b"lifetime", "timestamp", b"timestamp"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["arrows", b"arrows", "cubes", b"cubes", "cylinders", b"cylinders", "frame_id", b"frame_id", "frame_locked", b"frame_locked", "id", b"id", "lifetime", b"lifetime", "lines", b"lines", "metadata", b"metadata", "models", b"models", "spheres", b"spheres", "texts", b"texts", "timestamp", b"timestamp", "triangles", b"triangles"]) -> None: ...

global___SceneEntity = SceneEntity
